]> git.lizzy.rs Git - rust.git/blob - src/ci/init_repo.sh
Rollup merge of #41135 - japaric:unstable-docs, r=steveklabnik
[rust.git] / src / ci / init_repo.sh
1 #!/bin/bash
2 # Copyright 2016 The Rust Project Developers. See the COPYRIGHT
3 # file at the top-level directory of this distribution and at
4 # http://rust-lang.org/COPYRIGHT.
5 #
6 # Licensed under the Apache License, Version 2.0 <LICENSE-APACHE or
7 # http://www.apache.org/licenses/LICENSE-2.0> or the MIT license
8 # <LICENSE-MIT or http://opensource.org/licenses/MIT>, at your
9 # option. This file may not be copied, modified, or distributed
10 # except according to those terms.
11
12 set -o errexit
13 set -o pipefail
14 set -o nounset
15
16 set -o xtrace
17
18 ci_dir=$(cd $(dirname $0) && pwd)
19 . "$ci_dir/shared.sh"
20
21 REPO_DIR="$1"
22 CACHE_DIR="$2"
23
24 cache_src_dir="$CACHE_DIR/src"
25 # If the layout of the cache directory changes, bump the number here
26 # (and anywhere else this file is referenced) so the cache is wiped
27 cache_valid_file="$CACHE_DIR/cache_valid1"
28
29 if [ ! -d "$REPO_DIR" -o ! -d "$REPO_DIR/.git" ]; then
30     echo "Error: $REPO_DIR does not exist or is not a git repo"
31     exit 1
32 fi
33 cd $REPO_DIR
34 if [ ! -d "$CACHE_DIR" ]; then
35     echo "Error: $CACHE_DIR does not exist or is not an absolute path"
36     exit 1
37 fi
38
39 # Wipe the cache if it's not valid, or mark it as invalid while we update it
40 if [ ! -f "$cache_valid_file" ]; then
41     rm -rf "$CACHE_DIR"
42     mkdir "$CACHE_DIR"
43 else
44     set +o errexit
45     stat_lines=$(cd "$cache_src_dir" && git status --porcelain | wc -l)
46     stat_ec=$(cd "$cache_src_dir" && git status >/dev/null 2>&1; echo $?)
47     set -o errexit
48     if [ ! -d "$cache_src_dir/.git" -o $stat_lines != 0 -o $stat_ec != 0 ]; then
49         # Something is badly wrong - the cache valid file is here, but something
50         # about the git repo is fishy. Nuke it all, just in case
51         echo "WARNING: $cache_valid_file exists but bad repo: l:$stat_lines, ec:$stat_ec"
52         rm -rf "$CACHE_DIR"
53         mkdir "$CACHE_DIR"
54     else
55         rm "$cache_valid_file"
56     fi
57 fi
58
59 # Update the cache (a pristine copy of the rust source master)
60 if [ ! -d "$cache_src_dir/.git" ]; then
61     retry sh -c "rm -rf $cache_src_dir && mkdir -p $cache_src_dir && \
62         git clone https://github.com/rust-lang/rust.git $cache_src_dir"
63 fi
64 retry sh -c "cd $cache_src_dir && git reset --hard && git pull"
65 retry sh -c "cd $cache_src_dir && \
66     git submodule deinit -f . && git submodule sync && git submodule update --init"
67
68 # Cache was updated without errors, mark it as valid
69 touch "$cache_valid_file"
70
71 # Update the submodules of the repo we're in, using the pristine repo as
72 # a cache for any object files
73 # No, `git submodule foreach` won't work:
74 # http://stackoverflow.com/questions/12641469/list-submodules-in-a-git-repository
75 modules="$(git config --file .gitmodules --get-regexp '\.path$' | cut -d' ' -f2)"
76 for module in $modules; do
77     if [ ! -d "$cache_src_dir/$module" ]; then
78         echo "WARNING: $module not found in pristine repo"
79         retry sh -c "git submodule deinit -f $module && git submodule update --init $module"
80         continue
81     fi
82     retry sh -c "git submodule deinit -f $module && \
83         git submodule update --init --reference $cache_src_dir/$module $module"
84 done